const app = getApp();
const { goodsApi, DFSImg, $themeToLink, $themeAddToCard,log } = app;

const componentOptions = {
  // 组件选项
  options: {
    multipleSlots: true
  },
  behaviors: [],
  properties: {
    datas: {
      type: Object
    },
    items: {
      type: Object
    },
    indexs: {
      type: Number
    }
  },
  // 组件数据
  data: {
    isPageHidden: false, // 页面是否处于隐藏状态
    timeData: {},
    imgFillType: "widthFix",
  },
  // 数据监听器
  observers: {},
  // 组件方法
  methods: {
    init() {
      let datas = this.data.datas
      let { imgFillType } = this.data;
      if(datas.componentData.angleSignImg && datas.componentData.angleSignImg.lenght != 0){
        datas.componentData.angleSignImg = DFSImg(datas.componentData.angleSignImg,150,150,1)
      }
      if (datas.componentData.style === 'rowList' || datas.componentData.style === 'heap') {
        imgFillType = "aspectFit"
      } else if (datas.componentData.style == 'waterfall' && datas.componentData.imgShowMode == "1") {
        imgFillType = "aspectFill"
      } else {
        imgFillType = "widthFix"
      }
      this.setData({
        datas,
        imgFillType
      })
      log.info('datas');
    },
    
    getSaleTime(val) {
      return new Date(val.replace(/-/g, "/")).getTime() - new Date().getTime();
    },
    showVipPrice(index) {
      // 索引 0 显示价格 1显示名称
      let showFlag = false;
      let vipPrice = this.items["minPriceAfterRecommendedCardPriceTable"];
      if (vipPrice && Number(vipPrice) < Number(this.items["minPrice"])) {
        showFlag = true;
      }
      console.log(showFlag, "------------760");
      return showFlag;
    },
    showVipTag(index) {
      // 索引 0 显示价格 1显示名称
      let showFlag = false;
      let vipPrice = this.items["minPriceAfterRecommendedCardPriceTable"];
      let showTag = this.items["recommendedCardMinPricePriceTableName"];
      if (
        vipPrice &&
        showTag &&
        Number(vipPrice) <= Number(this.items["minPrice"])
      ) {
        showFlag = true;
      }
      return showFlag;
    },
    onChange(e) {
      this.setData({ timeData: e.detail });
    },
    onclickProduct(e) {
      let { goodsType } = this.data.datas.componentData;
      let {
        shopName,
        productId,
        productName,
        terminalProductId,
        terminalGoodsMixId
      } = this.data.items;
      let linkVal = "";
      if (goodsType == 0) {
        linkVal = `/goods/${productId}?terminalProductId=${terminalProductId}`;
      } else if (goodsType == 1) {
        linkVal = `/pointShop/goodsDetail?productId${productId}&terminalProductId=${terminalProductId}&terminalGoodsMixId=${terminalGoodsMixId}`;
      }
      app.trackCpn(e, this.data.datas.componentName, {
        shopName,productId,productName,terminalProductId,terminalGoodsMixId
      })
      $themeToLink({
        type: 1,
        link: linkVal
      });
    },
    onclickBuynow(e) {
      let { btnType } = this.data.datas.componentData;
      let _this = this;
      let {
        minProductGoodsMixid,
        minProductGoodsId,
        productName,
        minGoodsId,
        shopName
      } = this.data.items;
      let linkVal = "";
      if (btnType < 6) {
        // 加入购物车
        console.log("加入购物车");
        // $themeAddToCard(this.data.items);
        console.log(app.globalData.shopInfo.whetherOpenEnterprisesWantGoods - 0,'app.globalData.shopInfo=')
        let { whetherToEnableQuickPurchase } = app.shop_configuration;
        if (whetherToEnableQuickPurchase == 1) {
          // 快速加购
          $themeAddToCard(this.data.items);
        } else {
          // 选规格加购
          if (app.globalData.shopInfo.whetherOpenEnterprisesWantGoods - 0 == 1) {
            // 开启企业要货加购
            app.openTwoBAddCart(_this.data.items);
          } else {
            app.openSelectGoods(_this.data.items);
          }
        }
      } else {
        // 进入确认订单
        linkVal = `/order/orderConfirm?productGoodsMixId=${minProductGoodsMixid}&productGoodsId=${minProductGoodsId}&goodsId=${minGoodsId}&qty=1&goodsString=null&source=3`;
      }
      console.log(linkVal, "-------90");
      app.trackCpn(e, this.data.datas.componentName, {
        shopName,minGoodsId,productName,minProductGoodsId,minProductGoodsMixid
      })
      $themeToLink({ type: 1, link: linkVal });
    },
    toMerchants(e) {
      let { orgId } = this.data.items;
      app.trackCpn(e, this.data.datas.componentName, 'toMerchants')
       $themeToLink({ type: 1, link: `/merchantsDetail/${orgId}` });

    },
    errorFunction(e) {
      this.setData({
        "items.productImgUrl":"https://cdn.mayi888.com/product/85pdScJ5ch.jpg?x-oss-process=image/resize,m_pad,limit_0,w_400,h_400",
        "items.coverImage":"https://cdn.mayi888.com/product/85pdScJ5ch.jpg?x-oss-process=image/resize,m_pad,limit_0,w_400,h_400",
      })
    },
  },
  // 组件生命周期
  lifetimes: {
    created() {},
    attached() {
      this.init();
    },
    ready() {},
    moved() {},
    detached() {}
  },
  definitionFilter() {},
  // 页面生命周期
  pageLifetimes: {
    // 页面被展示
    show() {
      const { isPageHidden } = this.data;

      // show事件发生前，页面不是处于隐藏状态时
      if (!isPageHidden) {
        return;
      }

      // 重新执行定时器等操作
    },
    // 页面被隐藏
    hide() {
      this.setData({
        isPageHidden: true
      });

      // 清除定时器等操作
    },
    // 页面尺寸变化时
    resize() {}
  }
};

Component(componentOptions)
